# Facebook graphapi js connector

When your customer want you to make a facebook integration you should head over to [facebook for developers](https://developers.facebook.com/apps/457999228049338/fb-login/quickstart/), and check out the [Graph API](https://developers.facebook.com/docs/graph-api), and also visit the group [Facebook Developer Community](https://www.facebook.com/groups/fbdevelopers/) at facebook.


Be aware; This package is only a personal side-project, use with caution.
The author has no affiliation with facebook

## Prerequisite
- You should know your facebook app's APP ID
- You should set your app to use Website as a platform, and define the url path of your app


## Install
With [npm](https://npmjs.org/) installed, run

`$ npm install --save facebook-graphapi-js-connector`

## Usage

```html
  <button class="login-button" type="button" name="button">Login</button>
  <button class="logout-button" type="button" name="button">Logout</button>
  <fieldset>
    <div>
      <input type="text" id="selectedPageIdInput">
      <label for="selectedPageIdInput">Page ID</label>
    </div>
    <button class="get-access-token-button" type="button" name="button">Get page access token</button>
  </fieldset>
```

```javascript
  import graphapi from 'facebook-graphapi-js-connector';
  graphapi.init({appId: <'Your facebook app ID'>});

  const logout_button = document.querySelector('.logout-button');
  logout_button.onclick = () => {
    graphapi.logout();
  }

  const get_access_token_button = document.querySelector('.get-access-token-button');
  get_access_token_button.onclick = () => {
    graphapi.getPageAccessToken({pageId: document.getElementById('selectedPageIdInput').value});
  }
```

## Why?
Just for fun...
