let state = {
  user_logged_in: false,
  user_id: '',
  user_access_token: '',
  user_name: '',
  pages: null
}

exports.printMsg = function() {
  console.log("This is a message from the demo package");
}

exports.init = (props) => {
  new Promise((resolve, reject) => {
    console.log('initializing fb connect');
    const {
      appId = '',
      cookie = 'true',
      xfbml = 'true',
      version = 'v2.11'
    } = props;

    window.fbAsyncInit = () => {
      FB.init({
        appId,
        cookie,
        xfbml,
        version
      });

      FB.AppEvents.logPageView();
      console.log(FB);
      resolve();
    };

    (function(d, s, id){
      var js, fjs = d.getElementsByTagName(s)[0];
      if (d.getElementById(id)) {return;}
      js = d.createElement(s); js.id = id;
      js.src = "https://connect.facebook.net/en_US/sdk.js";
      fjs.parentNode.insertBefore(js, fjs);
    }(document, 'script', 'facebook-jssdk'));

    return new Promise((resolve, reject) => {
        return FB.getLoginStatus(response => {
            console.log('checking login status...');
            if (response.status === 'connected') {
                //console.log(response, response.authResponse.userID);
                resolve(response.authResponse.userID);
            } else {
                console.log('failed to get user access token', response);
                reject();
            }
        })
    })
    .then(response => {
        console.log(`user ${response} is logged in`);
        loggedIn(response);
    }).catch(() => {
      console.log('user is not logged in');
    })

  });
}

exports.login = () => {
  return new Promise((resolve, reject) => {
    FB.login(response => {
      if (response.authResponse) {
       console.log('Welcome!  Fetching your information.... ');
       FB.api('/me', response => {
         console.log('Good to see you, ' + response.name + '.');
         loggedIn(response);
         resolve(response);
       });
      } else {
       console.log('User cancelled login or did not fully authorize.');
       reject(response);
      }
    });
  });
};

exports.logout = () => {
  return new Promise((resolve, reject) => {
      FB.logout(response => {
        console.log('Goodbye.')
        resolve(response);
      });
  });
};

const loggedIn = (response) => {
  new Promise((resolve, reject) => {
    state = {
      ...state,
      user_id: response.id,
      user_name: response.name,
      user_logged_in: true
    }
  }).then(() => {
    getUserAccessToken();
  })
}

exports.getPagesWhereUserIsAdmin = () => {
  return new Promise((resolve, reject) => {
      return FB.api('/me/accounts', {
          fields: 'manage_pages,name',
      }, (response) => {
          if (!response || response.error) {
              console.log('failed to get pages where user is admin: ', response);
              reject(response)
          } else {
              console.log('got pages where user is admin: ', response);
              new Promise((resolve, reject) => {
                state = {
                  ...state,
                  pages: response.data
                }
              })
              resolve(response.data)
          }
      })
  });
}

exports.getPageAccessToken = (props) => {
  const {
    pageId
  } = props;
  return new Promise((resolve, reject) => {
      return FB.api( pageId, 'GET', {
              fields: 'access_token'
          }, response => {
              console.log('waiting for page access token...');
              if (!response || response.error) {
                  console.log('failed to get page access token', response);
                  reject(response)
              } else {
                  console.log('current pages access token', response.access_token);
                  resolve(response.access_token)
              }
          }
        );
  });
}
